
local W = CreateFrame("Frame") -- cargador
local UFM = { } --unit frame mixin
local C_NamePlate = C_NamePlate
local wantedguid

SpellEvents = { 
	["SPELL_DAMAGE"] = true, 
	["SPELL_CAST_START"] = true, 
	["SPELL_PERIODIC_DAMAGE"] = true, 
	["RANGE_DAMAGE"] = true, 
	["SWING_DAMAGE"] = true, 
}

P = CreateFrame("Frame")
P:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
P:SetScript("OnEvent", function(_, _, _, event, subevent, guid, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, prefixParam1, prefixParam2, dummyparam, suffixParam1, suffixParam2)

--timeStamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, prefixParam1, prefixParam2, dummyparam, suffixParam1, suffixParam2 = ...
	if SpellEvents[event] then
		if sourceName and bit.band(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then
			wantedguid = guid
			--print("flag me pega: "..sourceFlags)
			--print("guid me pega: "..wantedguid)
		end
	end
end)



function W:NAME_PLATE_CREATED(nameplate,unit)
 -- print("NAME_PLATE_CREATED",nameplate:GetName(),nameplate:GetSize())
	--C_NamePlate.GetNamePlateForUnit,
	--C_NamePlate.GetNamePlateSizes,
	--C_NamePlate.GetNamePlates,
	--C_NamePlate.GetNumNamePlateMotionTypes,
	--C_NamePlate.SetNamePlateSizes,
  local unitFrame = CreateFrame("Button", nameplate:GetName().."UnitFrame", nameplate)
  unitFrame:SetAllPoints()
  nameplate.unitFrame = unitFrame

  Mixin(unitFrame, UFM)
  --create subframes (health, name, etc...)
   -- guid = UnitGUID(unit)
 -- print(nameplate:GetName().."UnitFrame")

  unitFrame:Create(nameplate)  -- este es el outper
end
 
function W:NAME_PLATE_UNIT_ADDED(unit)
  guid = UnitGUID(unit)
  local nameplate = C_NamePlate.GetNamePlateForUnit(unit)
 -- print(unitFrame)
--  print(algo)
 -- print("added: "..guid)
  inInstance, instanceType = IsInInstance()
 --if inInstance then nameplate.unitFrame:UnitRemoved(nameplate,unit) end
 	if wantedguid ~= nil then
		if wantedguid == guid then
			nameplate.unitFrame:UnitAdded(nameplate,unit)
		else
		  nameplate.unitFrame:UnitRemoved(nameplate,unit)

		end
	end
 --nameplate.unitFrame:UnitRemoved(nameplate,unit) end

end
 
function W:NAME_PLATE_UNIT_REMOVED(unit,guid)
  local nameplate = C_NamePlate.GetNamePlateForUnit(unit)
  nameplate.unitFrame:UnitRemoved(nameplate,unit)
  --guid = UnitGUID(unit)
  --	print("remove: "..guid)

end
 
function W:OnEvent(event,...)
  --print("W:OnEvent",...)
    self[event](event,...)
end
 
W:SetScript("OnEvent", W.OnEvent)
 
W:RegisterEvent("NAME_PLATE_CREATED")
W:RegisterEvent("NAME_PLATE_UNIT_ADDED")
W:RegisterEvent("NAME_PLATE_UNIT_REMOVED")

function UFM:Create(nameplate)
  --print("UFM:Create",self:GetName(),nameplate:GetName())
	--if wantedguid == guid then
	--print(wantedguid)
	--print(nameplate)
--	if wantedguid ~= nil then
	--print("wantedguid: "..wantedguid)
	--	if wantedguid == guid then

		local icono = self:CreateTexture(nil,"OVERLAY")
		icono:SetTexture("Interface\\Icons\\ability_hunter_beastcall02")
		--icono:SetTexture("Interface\\AddOns\\Bang_Bang\\Artwork\\bang_icono.tga")
		icono:SetSize(25,25)
		icono:SetPoint("TOP", 40, 15) -- horizontal, vertical
--		end
	--end
end

function UFM:UnitAdded(nameplate,unit,guid)
--  print("UFM:UnitAdded",self:GetName(),nameplate:GetName(),unit)
--self.guid = UnitGUID(unit)
  self.unit = unit
  self.inVehicle = UnitInVehicle(unit)
	--print("added guid: "..self.guid)
	--if wantedguid ~= nil then
	--print("wantedguid: "..wantedguid)
	--	if wantedguid == guid then
			self:Show()
	--	end
--	end
end


function UFM:UnitRemoved(nameplate,unit,guid)
 -- print("UFM:UnitRemoved",self:GetName(),nameplate:GetName(),unit)
 -- self.guid = UnitGUID(unit)
	--print("remove guid: "..self.guid)
  self.unit = nil
  self.inVehicle = nil
  self:Hide()
end