-- Copyright 2011 Xavier Ferrair aka Mortimer @ Outland [H] (deadlygm@gmail.com)
-- no code in this file may be used in other works without expressed permission

local bTimers;

local function newTimer(ico, time)
	if( time <= 0 ) then
		ico:SetText("");
	elseif( time < 600 ) then
		local d, h, m, s = ChatFrame_TimeBreakDown(time);
		ico:SetFormattedText("%1d:%02d", m, s);
	elseif( time < 3600 ) then
		local d, h, m, s = ChatFrame_TimeBreakDown(time);
		ico:SetFormattedText("%02d:%02d", m, s);
	else
		local d, h, m, s = ChatFrame_TimeBreakDown(time);
		ico:SetFormattedText("%1d:%02d", h, m);
	end
end

function Timers_OnLoad(self)
	hooksecurefunc("AuraButton_UpdateDuration", ICO_AuraButton_UpdateDuration);
		if( DEFAULT_CHAT_FRAME ) then
			DEFAULT_CHAT_FRAME:AddMessage("");
		end
	UIErrorsFrame:AddMessage("", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
end

function ICO_AuraButton_UpdateDuration(buffButton, timeLeft)
	if( SHOW_BUFF_DURATIONS == "1" ) then
		local duration = getglobal(buffButton:GetName().."Duration");
		if( timeLeft ) then
			newTimer(duration, timeLeft);
			duration:Show();
		else
			duration:Hide();
		end
	elseif( not bTimers ) then
		DEFAULT_CHAT_FRAME:AddMessage("", 1, 1, 0);
		bTimers = true;
	end
end

local BT = CreateFrame("frame")
BT:SetScript("OnEvent", function(self, event, ...)

Timers_OnLoad()

end)
