-- Copyright 2011 Xavier Ferrair aka Mortimer @ Outland [H] (deadlygm@gmail.com)
-- no code in this file may be used in other works without expressed permission

--local hk, honorKills, rating, ratingg, ratinggg, seasonWon, seasonWonn, seasonWonnn

local BB_Name = GetAddOnMetadata("Bang_Bang", "Name");
local BB_Version = tonumber(GetAddOnMetadata("Bang_Bang", "Version"));
local BB_Intro = "|cffDDDDDDBang! Bang! is your best allied if you like the PvP, especially if you like world-PvP. This add-on gives you severals improvements and new features that will make you enjoy even more your battles."
local name = UnitName("player");
local realmName = GetRealmName();

local f = CreateFrame("Frame")
f:RegisterEvent("PLAYER_LOGIN")
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:RegisterEvent("ADDON_LOADED")
f:SetScript("OnEvent", function(self, event, ...)
 
    if event == "ADDON_LOADED" and ... == "Bang_Bang" then
        if not BangDB then BangDB = {} end
        if not BangKills then BangKills = {} end
        if not BangDeaths then BangDeaths = {} end
        if not BangHateds then BangHateds = {} end
		--
        if not BangCharDB then BangCharDB = {} end
        if not BangCharKills then BangCharKills = {} end
        if not BangCharDeaths then BangCharDeaths = {} end
        if not BangCharHateds then BangCharHateds = {} end

		self:UnregisterEvent("ADDON_LOADED");
	end

	if event == "PLAYER_LOGIN" then
			Gui:Hide()
	-- DB
		if BangCharDB["Chk1"] == nil then BangCharDB["Chk1"] = true	end
		if BangCharDB["Chk2"] == nil then BangCharDB["Chk2"] = true	end
		if BangCharDB["Chk3"] == nil then BangCharDB["Chk3"] = true	end
		if BangCharDB["Chk4"] == nil then BangCharDB["Chk4"] = true	end
		if BangCharDB["Chk5"] == nil then BangCharDB["Chk5"] = true	end
		if BangCharDB["Chk6"] == nil then BangCharDB["Chk6"] = true	end
		if BangCharDB["Chk7"] == nil then BangCharDB["Chk7"] = true	end
		if BangCharDB["Chk8"] == nil then BangCharDB["Chk8"] = true	end
		--
		if BangDB["TTTT"] == nil then BangDB["TTTT"] = true	end
		if BangKills["TTTT"] == nil then BangKills["TTTT"] = 1 end
		if BangDeaths["TTTT"] == nil then BangDeaths["TTTT"] = 1 end
		if BangHateds["TTTT"] == nil then BangHateds["TTTT"] = true	end
		--
		if BangCharDB["TTTT"] == nil then BangCharDB["TTTT"] = true	end
		if BangCharKills["TTTT"] == nil then BangCharKills["TTTT"] = 1 end
		if BangCharDeaths["TTTT"] == nil then BangCharDeaths["TTTT"] = 1 end
		if BangCharHateds["TTTT"] == nil then BangCharHateds["TTTT"] = true	end
		
		if BangCharDB["walerterX"] == nil then BangCharDB["walerterX"] = 0 end
		if BangCharDB["walerterY"] == nil then BangCharDB["walerterY"] = -55 end
		
	end
	
	if (event == "PLAYER_ENTERING_WORLD") then
       if not IsAddOnLoaded("Blizzard_PVPUI") then
          LoadAddOn("Blizzard_PVPUI")
       end
       self:UnregisterEvent("PLAYER_ENTERING_WORLD")
    end
end)

function PvPanel()
     TogglePVPUI()
end

-----------------------
-- GUI
-----------------------
Gui = CreateFrame("Frame", "Gui", UIParent)
Gui:SetSize(450,400)
Gui:SetBackdrop( {
	bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
	edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
	tile = true,
	tileSize = 20,
	edgeSize = 20,
	insets = {left = 4, right = 4, top = 4, bottom = 4}
} )
Gui:SetBackdropColor(.05, .05, .05, 1)
    Gui:SetMovable(true)
    Gui:SetUserPlaced(true)
    Gui:RegisterForDrag("LeftButton")
    Gui:EnableMouse(true)
    Gui:SetScript("OnDragStart", function(self) Gui:StartMoving() end)
    Gui:SetScript("OnDragStop", function(self) Gui:StopMovingOrSizing() end)
	Gui:SetPoint("CENTER")
--
Gui.title = CreateFrame("MessageFrame", nil, Gui)
Gui.title:SetSize(200,35)
Gui.title:SetPoint("TOP",0,16)
Gui.title:SetBackdrop( {
	bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
	edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
--	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	tile = true,
	tileSize = 20,
	edgeSize = 20,
	insets = {left = 4, right = 4, top = 4, bottom = 4}
} )
Gui.title:SetBackdropColor(0, 0, 0, 1)
	local text = Gui.title:CreateFontString(nil, nil, 'GameFontHighlightLeft')
	text:SetPoint("CENTER"); text:SetJustifyH("CENTER"); text:SetWidth(200); text:SetHeight(35); text:SetSpacing(0)
	text:SetText("|cffFFD800Bang! Bang! "..BB_Version) -- color oro

--
Gui.intro = CreateFrame("Frame", nil, Gui)
Gui.intro:SetSize(410,100)
Gui.intro:SetPoint("TOP",0,-15)
--Gui.intro:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground",}) -- para ver frame
--Gui.intro:SetBackdropColor(1, 0, 0, 1) -- para ver frame color
	local text = Gui.intro:CreateFontString(nil, nil, 'GameFontHighlightLeft')
	text:SetPoint("TOPLEFT", 5, 20); text:SetWidth(410); text:SetHeight(100); text:SetSpacing(0)
	text:SetText(BB_Intro)
--
Gui.author = CreateFrame("MessageFrame", nil, Gui)
Gui.author:SetSize(170,40)
Gui.author:SetPoint("BOTTOM",130,10)
Gui.author:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Gui.author:SetFading(false)
Gui.author:SetSpacing(0)
Gui.author:AddMessage("Author:", .3, .3, .3, 1)
Gui.author:AddMessage("Mortimer - Outland", .3, .3, .3, 1)

Gui.author:SetJustifyH("RIGHT")
--
Gui.func1frame = CreateFrame("MessageFrame", nil, Gui)
Gui.func1frame:SetSize(370,200)
Gui.func1frame:SetPoint("TOP", 0, -115)
Gui.func1frame:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground",}) -- para ver frame
Gui.func1frame:SetBackdropColor(0, 0, 0, 1) -- para ver frame color
--
Gui.func1frame.tab = CreateFrame("MessageFrame", nil, Gui.func1frame)
Gui.func1frame.tab:SetSize(120,20)
Gui.func1frame.tab:SetPoint("TOP", 115, -210)
Gui.func1frame.tab:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Gui.func1frame.tab:SetFading(false)
Gui.func1frame.tab:AddMessage("Main", 1, .8, 0, 1) --color oro
Gui.func1frame.tab:SetJustifyH("RIGHT")
--
--Gui.func1frame.head = CreateFrame("SimpleHTML", nil, Gui.func1frame)
--Gui.func1frame.head:SetSize(345,146)
--Gui.func1frame.head:SetPoint("TOP", 0, 0)
--Gui.func1frame.head:SetFont('Fonts\\FRIZQT__.TTF', 12)
--Gui.func1frame.head:SetText("<html><body><p>|cffDDDDDDHay que pensar un texto corto.</p></body></html>")
--
Gui.func1frame.rankt = CreateFrame("MessageFrame", nil, Gui.func1frame)
Gui.func1frame.rankt:SetSize(70,80)
Gui.func1frame.rankt:SetPoint("BOTTOM", -60, 0)
Gui.func1frame.rankt:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Gui.func1frame.rankt:SetFading(false)
Gui.func1frame.rankt:SetSpacing(0)
Gui.func1frame.rankt:AddMessage("BRACKET",  1, .8, 0, 1)
Gui.func1frame.rankt:AddMessage("2v2", .8, .8, .8, 1)
Gui.func1frame.rankt:AddMessage("3v3", .9, .9, .9, 1)
Gui.func1frame.rankt:AddMessage("10v10", .8, .8, .8, 1)
Gui.func1frame.rankt:SetJustifyH("RIGHT")
--
	honorKills, honorPoints = GetPVPSessionStats("player")
	hk, highestRank = GetPVPLifetimeStats("player")
	rating, _, _, _, seasonWon = GetPersonalRatedInfo(1) --2v2
	ratingg, _, _, _, seasonWonn = GetPersonalRatedInfo(2) --3v3
	ratinggg, _, _, _, seasonWonnn = GetPersonalRatedInfo(4) --10v10
--
Gui.func1frame.rankw = CreateFrame("MessageFrame", nil, Gui.func1frame)
Gui.func1frame.rankw:SetSize(50,80)
Gui.func1frame.rankw:SetPoint("BOTTOM", 0, 0)
Gui.func1frame.rankw:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Gui.func1frame.rankw:SetFading(false)
Gui.func1frame.rankw:SetSpacing(0)
Gui.func1frame.rankw:AddMessage("WINS",  1, .8, 0, 1)
Gui.func1frame.rankw:AddMessage(seasonWon, .8, .8, .8, 1)-------------------------------------------------------------------------------------------------
Gui.func1frame.rankw:AddMessage(seasonWonn, .9, .9, .9, 1)
Gui.func1frame.rankw:AddMessage(seasonWonnn, .8, .8, .8, 1)
Gui.func1frame.rankw:SetJustifyH("CENTER")
--
Gui.func1frame.rankr = CreateFrame("MessageFrame", nil, Gui.func1frame)
Gui.func1frame.rankr:SetSize(50,80)
Gui.func1frame.rankr:SetPoint("BOTTOM", 55, 0)
Gui.func1frame.rankr:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Gui.func1frame.rankr:SetFading(false)
Gui.func1frame.rankr:SetSpacing(0)
Gui.func1frame.rankr:AddMessage("RATING",  1, .8, 0, 1)
Gui.func1frame.rankr:AddMessage(rating, .8, .8, .8, 1)
Gui.func1frame.rankr:AddMessage(ratingg, .9, .9, .9, 1)
Gui.func1frame.rankr:AddMessage(ratinggg, .8, .8, .8, 1)
Gui.func1frame.rankr:SetJustifyH("LEFT")
--
Gui.func2frame = CreateFrame("MessageFrame", nil, Gui)
Gui.func2frame:SetSize(370,200)
Gui.func2frame:SetPoint("TOP", 0, -115)
Gui.func2frame:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground",}) -- para ver frame
Gui.func2frame:SetBackdropColor(0, 0, 0, 1) -- para ver frame color
--
Gui.func2frame.tab = CreateFrame("MessageFrame", nil, Gui.func2frame)
Gui.func2frame.tab:SetSize(120,20)
Gui.func2frame.tab:SetPoint("TOP", 115, -210)
Gui.func2frame.tab:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Gui.func2frame.tab:SetFading(false)
Gui.func2frame.tab:SetSpacing(0)
Gui.func2frame.tab:AddMessage("Config", 1, .8, 0, 1) --color oro
Gui.func2frame.tab:SetJustifyH("RIGHT")
--
Gui.func2frame.head = CreateFrame("SimpleHTML", nil, Gui.func2frame)
Gui.func2frame.head:SetSize(345,146)
Gui.func2frame.head:SetPoint("TOP", 0, 0)
Gui.func2frame.head:SetFont('Fonts\\FRIZQT__.TTF', 12);
Gui.func2frame.head:SetText("<html><body><p>|cffDDDDDDMark your own settings:</p></body></html>")
--
Gui.func2frame.foot = CreateFrame("SimpleHTML", nil, Gui.func2frame)
Gui.func2frame.foot:SetSize(340,35)
Gui.func2frame.foot:SetPoint("BOTTOMLEFT", 10, -15)
Gui.func2frame.foot:SetFont('Fonts\\FRIZQT__.TTF', 12);
Gui.func2frame.foot:SetText("<html><body><p>|cffDDDDDDContact us if have some suggestion.</p></body></html>")
--
Gui.func2frame.chk1 = CreateFrame("CheckButton", "Chk1", Gui.func2frame, "UICheckButtonTemplate")
Gui.func2frame.chk1:ClearAllPoints()
Gui.func2frame.chk1:SetPoint("CENTER", -140, 50)
_G[Gui.func2frame.chk1:GetName() .. "Text"]:SetText("|cffDDDDDDSound when death")
Gui.func2frame.chk1:SetScript("OnClick", function(self, event, ...)
	if self:GetChecked() then
		BangCharDB.Chk1 = true; print("|cffFFD800Sound when death |cff2EFE2EON");
	else 
		BangCharDB.Chk1 = false; print("|cffFFD800Sound when death |cffFE2E2EOFF");
	end
end)
Gui.func2frame.chk1:SetScript('OnShow', function(self) self:SetChecked(BangCharDB.Chk1) end)
--
Gui.func2frame.chk2 = CreateFrame("CheckButton", "chk2", Gui.func2frame, "UICheckButtonTemplate")
Gui.func2frame.chk2:ClearAllPoints()
Gui.func2frame.chk2:SetPoint("CENTER", -140, 20)
_G[Gui.func2frame.chk2:GetName() .. "Text"]:SetText("|cffDDDDDDSound when resurrect")
Gui.func2frame.chk2:SetScript("OnClick", function(self, event, ...)
	if self:GetChecked() then
		BangCharDB.Chk2 = true; print("|cffFFD800Sound when resurrect |cff2EFE2EON");
	else 
		BangCharDB.Chk2 = false; print("|cffFFD800Sound when resurrect |cffFE2E2EOFF");
	end
end)
Gui.func2frame.chk2:SetScript('OnShow', function(self) self:SetChecked(BangCharDB.Chk2) end)
--
Gui.func2frame.chk3 = CreateFrame("CheckButton", "chk3", Gui.func2frame, "UICheckButtonTemplate")
Gui.func2frame.chk3:ClearAllPoints()
Gui.func2frame.chk3:SetPoint("CENTER", -140, -10)
_G[Gui.func2frame.chk3:GetName() .. "Text"]:SetText("|cffDDDDDDEmote when kill")
Gui.func2frame.chk3:SetScript("OnClick", function(self, event, ...)
	if self:GetChecked() then
		BangCharDB.Chk3 = true; print("|cffFFD800Emote when kill |cff2EFE2EON");
	else 
		BangCharDB.Chk3 = false; print("|cffFFD800Emote when kill |cffFE2E2EOFF");
	end
end)
Gui.func2frame.chk3:SetScript('OnShow', function(self) self:SetChecked(BangCharDB.Chk3) end)
--
Gui.func2frame.chk4 = CreateFrame("CheckButton", "chk4", Gui.func2frame, "UICheckButtonTemplate")
Gui.func2frame.chk4:ClearAllPoints()
Gui.func2frame.chk4:SetPoint("CENTER", -140, -40)
_G[Gui.func2frame.chk4:GetName() .. "Text"]:SetText("|cffDDDDDDEmote when interrumpt")
Gui.func2frame.chk4:SetScript("OnClick", function(self, event, ...)
	if self:GetChecked() then
		BangCharDB.Chk4 = true; print("|cffFFD800Emote when interrumpt |cff2EFE2EON");
	else 
		BangCharDB.Chk4 = false; print("|cffFFD800Emote when interrumpt |cffFE2E2EOFF");
	end
end)
Gui.func2frame.chk4:SetScript('OnShow', function(self) self:SetChecked(BangCharDB.Chk4) end)
--
Gui.func2frame.chk5 = CreateFrame("CheckButton", "chk5", Gui.func2frame, "UICheckButtonTemplate")
Gui.func2frame.chk5:ClearAllPoints()
Gui.func2frame.chk5:SetPoint("CENTER", 20, 50)
_G[Gui.func2frame.chk5:GetName() .. "Text"]:SetText("|cffDDDDDDStreak messages")
Gui.func2frame.chk5:SetScript("OnClick", function(self, event, ...)
	if self:GetChecked() then
		BangCharDB.Chk5 = true; print("|cffFFD800Streak messages |cff2EFE2EON");
	else 
		BangCharDB.Chk5 = false; print("|cffFFD800Streak messages |cffFE2E2EOFF");
	end
end)
Gui.func2frame.chk5:SetScript('OnShow', function(self) self:SetChecked(BangCharDB.Chk5) end)
--
Gui.func2frame.chk6 = CreateFrame("CheckButton", "chk6", Gui.func2frame, "UICheckButtonTemplate")
Gui.func2frame.chk6:ClearAllPoints()
Gui.func2frame.chk6:SetPoint("CENTER", 20, 20)
_G[Gui.func2frame.chk6:GetName() .. "Text"]:SetText("|cffDDDDDDMedallion/racial alerter")
Gui.func2frame.chk6:SetScript("OnClick", function(self, event, ...)
	if self:GetChecked() then
		BangCharDB.Chk6 = true; print("|cffFFD800Medallion or racial alerter |cff2EFE2EON");
	else 
		BangCharDB.Chk6 = false; print("|cffFFD800Medallion or racial alerter |cffFE2E2EOFF");
	end
end)
Gui.func2frame.chk6:SetScript('OnShow', function(self) self:SetChecked(BangCharDB.Chk6) end)
--
Gui.func2frame.chk7 = CreateFrame("CheckButton", "chk7", Gui.func2frame, "UICheckButtonTemplate")
Gui.func2frame.chk7:ClearAllPoints()
Gui.func2frame.chk7:SetPoint("CENTER", 20, -10)
_G[Gui.func2frame.chk7:GetName() .. "Text"]:SetText("|cffDDDDDDBG assist buttons")
Gui.func2frame.chk7:SetScript("OnClick", function(self, event, ...)
	if self:GetChecked() then
		BangCharDB.Chk7 = true; print("|cffFFD800Battlegrounds assist buttons |cff2EFE2EON");
	else 
		BangCharDB.Chk7 = false; print("|cffFFD800Battlegrounds assist buttons |cffFE2E2EOFF");
	end
end)
Gui.func2frame.chk7:SetScript('OnShow', function(self) self:SetChecked(BangCharDB.Chk7) end)
--[[
Gui.func2frame.chk8 = CreateFrame("CheckButton", "chk8", Gui.func2frame, "UICheckButtonTemplate")
Gui.func2frame.chk8:ClearAllPoints()
Gui.func2frame.chk8:SetPoint("CENTER", 20, -40)
_G[Gui.func2frame.chk8:GetName() .. "Text"]:SetText("|cffDDDDDDUnder construction")
Gui.func2frame.chk8:SetScript("OnClick", function(self, event, ...)
	if self:GetChecked() then BangCharDB.Chk8 = true else BangCharDB.Chk8 = false end end)
Gui.func2frame.chk8:SetScript('OnShow', function(self) self:SetChecked(BangCharDB.Chk8) end)
]]--
Gui.func3frame = CreateFrame("MessageFrame", nil, Gui)
Gui.func3frame:SetSize(370,200)
Gui.func3frame:SetPoint("TOP", 0, -115)
Gui.func3frame:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground",}) -- para ver frame
Gui.func3frame:SetBackdropColor(0, 0, 0, 1) -- para ver frame color
--
Gui.func3frame.tab = CreateFrame("MessageFrame", nil, Gui.func3frame)
Gui.func3frame.tab:SetSize(120,20)
Gui.func3frame.tab:SetPoint("TOP", 115, -210)
Gui.func3frame.tab:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Gui.func3frame.tab:SetFading(false)
Gui.func3frame.tab:AddMessage("Wanted List", 1, .8, 0, 1) --color oro
Gui.func3frame.tab:SetJustifyH("RIGHT")
--
Gui.func3frame.head = CreateFrame("SimpleHTML", nil, Gui.func3frame)
Gui.func3frame.head:SetSize(345,146)
Gui.func3frame.head:SetPoint("TOP", 0, 0)
Gui.func3frame.head:SetFont('Fonts\\FRIZQT__.TTF', 12)
Gui.func3frame.head:SetSpacing(0)
Gui.func3frame.head:SetText("<html><body><p>|cffDDDDDDWrite the name of your enemy and add him to your wanted list and find him more easy.</p></body></html>")
--
Gui.func3frame.type = CreateFrame("SimpleHTML", nil, Gui.func3frame)
Gui.func3frame.type:SetSize(200,35)
Gui.func3frame.type:SetPoint("CENTER", -45, 40)
Gui.func3frame.type:SetFont('Fonts\\FRIZQT__.TTF', 12);
Gui.func3frame.type:SetText("<html><body><p>|cff777777Use Name-Realm always</p></body></html>")
--
Gui.func3frame.foot = CreateFrame("SimpleHTML", nil, Gui.func3frame)
Gui.func3frame.foot:SetSize(200,35)
Gui.func3frame.foot:SetPoint("BOTTOMLEFT", 10, -15)
Gui.func3frame.foot:SetFont('Fonts\\FRIZQT__.TTF', 12);
Gui.func3frame.foot:SetText("<html><body><p>|cffDDDDDDEnjoy hunting!</p></body></html>")
--
Gui.func3frame.input = CreateFrame("EditBox", "addenemy", Gui.func3frame, 'InputBoxTemplate')
Gui.func3frame.input:SetSize(200,22)
Gui.func3frame.input:SetAutoFocus(false)
Gui.func3frame.input:SetMaxLetters(30)
Gui.func3frame.input:SetPoint("CENTER", -65, 30)
Gui.func3frame.input:SetScript('OnChar', function(self, addenemy)
    self:GetParent().addenemy = self:GetText()
end)
--
Gui.func3frame.add = CreateFrame("Button", "addenemy", Gui.func3frame, "UIPanelButtonTemplate")
Gui.func3frame.add:SetSize(50,22)
Gui.func3frame.add:SetPoint("CENTER", 70, 30)
Gui.func3frame.add:SetText("Add")
Gui.func3frame.add:SetScript("OnClick", function(self, addenemy)
	BangHateds[self:GetParent().addenemy] = true;
    print("|cff009900+ Added |r" ..self:GetParent().addenemy.." |cff009900to wanted list.")
	Gui.func3frame.input:SetText("")
end)
--
 Gui.func3frame.list = CreateFrame("Button", "delenemy", Gui.func3frame, "UIDropDownMenuTemplate")
 Gui.func3frame.list:SetPoint("CENTER", -35, -12)
--
Gui.func3frame.test = CreateFrame("Button", "addenemy", Gui.func3frame, "UIPanelButtonTemplate")
Gui.func3frame.test:SetSize(50,22)
Gui.func3frame.test:SetPoint("CENTER", 70, -50)
Gui.func3frame.test:SetText("Test")
Gui.func3frame.test:SetScript("OnClick", function(self, event, ...)
	HateList.adv:AddMessage("|cffFE2E2EYour enemy |cffDDDDDDWanted-Name |cffFE2E2Eis near", .9, .9, .9, 1)
	HateList:Show()
end)
--
Gui.func4frame = CreateFrame("MessageFrame", nil, Gui)
Gui.func4frame:SetSize(370,200)
Gui.func4frame:SetPoint("TOP", 0, -115)
Gui.func4frame:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground",}) -- para ver frame
Gui.func4frame:SetBackdropColor(0, 0, 0, 1) -- para ver frame color
--
Gui.func4frame.tab = CreateFrame("MessageFrame", nil, Gui.func4frame)
Gui.func4frame.tab:SetSize(120,20)
Gui.func4frame.tab:SetPoint("TOP", 115, -210)
Gui.func4frame.tab:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Gui.func4frame.tab:SetFading(false)
Gui.func4frame.tab:AddMessage("Credits", 1, .8, 0, 1) --color oro
Gui.func4frame.tab:SetJustifyH("RIGHT")
--
Gui.func4frame.head = CreateFrame("SimpleHTML", nil, Gui.func4frame)
Gui.func4frame.head:SetSize(345,146)
Gui.func4frame.head:SetPoint("TOP", 0, 0)
Gui.func4frame.head:SetFont('Fonts\\FRIZQT__.TTF', 12)
Gui.func4frame.head:SetSpacing(0)
Gui.func4frame.head:SetText("<html><body><p>|cffDDDDDDSpecial thanks to the following people for their assistance with this project:</p></body></html>")

Gui.func4frame.block = CreateFrame("SimpleHTML", nil, Gui.func4frame)
Gui.func4frame.block:SetSize(360,146)
Gui.func4frame.block:SetPoint("TOP", 10, -45)
Gui.func4frame.block:SetFont('Fonts\\FRIZQT__.TTF', 12)
Gui.func4frame.block:SetSpacing(0)
Gui.func4frame.block:SetText("<html><body><p>|cffFFD800Amenamaste - Outland  |cff555555beta tester</p><p>|cffFFD800Aurka - DunModr  |cff555555supp. streamer: twitch.com/aurkalol</p><p>|cffFFD800Drpewpew - DunModr  |cff555555translator</p><p>|cffFFD800Ryukek - TwistingNether  |cff555555beta tester</p><p>|cffFFD800Tito - Stormscale  |cff555555main assistant</p><p>|cffFFD800Woolfwood - Sanguino  |cff555555alpha tester</p></body></html>")
--Gui.func4frame.block:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground",}) -- para ver frame
--Gui.func4frame.block:SetBackdropColor(1, 0, 0, 1) -- para ver frame color

Gui.func4frame.foot = CreateFrame("SimpleHTML", nil, Gui.func4frame)
Gui.func4frame.foot:SetSize(340,35)
Gui.func4frame.foot:SetPoint("BOTTOMLEFT", 10, -15)
Gui.func4frame.foot:SetFont('Fonts\\FRIZQT__.TTF', 12)
Gui.func4frame.foot:SetSpacing(0)
Gui.func4frame.foot:SetText("<html><body><p>|cffDDDDDDAlso thanks to all who use and support it.</p></body></html>")
--
Gui.buttonC = CreateFrame("Button",nil,Gui,"UIPanelButtonTemplate")
Gui.buttonC:SetSize(75,22)
Gui.buttonC:SetPoint("BOTTOM", 0, 20)
Gui.buttonC:SetText("Close")
Gui.buttonC:SetScript("OnClick", function()
		Gui:Hide()
end)
--
Gui.buttonBG = CreateFrame("Button",nil,Gui,"UIPanelButtonTemplate")
Gui.buttonBG:SetSize(75,22)
Gui.buttonBG:SetPoint("BOTTOM", -40, 50)
Gui.buttonBG:SetText("PvP Panel")
Gui.buttonBG:SetScript("OnClick", function(self,event, ...)
		TogglePVPUI()
end)
--
Gui.buttonBG = CreateFrame("Button",nil,Gui,"UIPanelButtonTemplate")
Gui.buttonBG:SetSize(75,22)
Gui.buttonBG:SetPoint("BOTTOM", 40, 50)
Gui.buttonBG:SetText("Reload UI")
Gui.buttonBG:SetScript("OnClick", function(self,event, ...)
		ReloadUI()
end)
--
Gui.action1 = CreateFrame("Button",nil,Gui,"UIPanelButtonTemplate")
Gui.action1:SetSize(75,22)
Gui.action1:SetPoint("TOP", -120, -82)
Gui.action1:SetText("Main")
Gui.action1:SetScript("OnClick", function()
	Gui.func1frame:Show()
	Gui.func2frame:Hide()
	Gui.func3frame:Hide()
	Gui.func4frame:Hide()
end)
--
Gui.action2 = CreateFrame("Button",nil,Gui,"UIPanelButtonTemplate")
Gui.action2:SetSize(75,22)
Gui.action2:SetPoint("TOP", -40, -82)
Gui.action2:SetText("Config")
Gui.action2:SetScript("OnClick", function()
	Gui.func1frame:Hide()
	Gui.func2frame:Show()
	Gui.func3frame:Hide()
	Gui.func4frame:Hide()
end)
--
Gui.action3 = CreateFrame("Button",nil,Gui,"UIPanelButtonTemplate")
Gui.action3:SetSize(75,22)
Gui.action3:SetPoint("TOP", 40, -82)
Gui.action3:SetText("Wanted")
Gui.action3:SetScript("OnClick", function()
	Gui.func1frame:Hide()
	Gui.func2frame:Hide()
	Gui.func3frame:Show()
	Gui.func4frame:Hide()
end)
--
Gui.action4 = CreateFrame("Button",nil,Gui,"UIPanelButtonTemplate")
Gui.action4:SetSize(75,22)
Gui.action4:SetPoint("TOP", 120, -82)
Gui.action4:SetText("Credits")
Gui.action4:SetScript("OnClick", function()
	Gui.func1frame:Hide()
	Gui.func2frame:Hide()
	Gui.func3frame:Hide()
	Gui.func4frame:Show()
end)
--

--
local BangDB = CreateFrame("FRAME", "AddonFrame");
BangDB:RegisterEvent("ADDON_LOADED");
BangDB:RegisterEvent("PLAYER_ENTERING_WORLD");
 
local function eventHandler(self, event, ...)
--[[
    if event == "ADDON_LOADED" and ... == "Bang_Bang" then
        if not BangHateds then BangHateds = {} end
        if not BangCharKills then BangCharKills = {} end
        if not BangCharHateds then BangCharHateds = {} end
 
        self:UnregisterEvent("ADDON_LOADED");
    end
]]--

-- CONTENIDO SELECTOR WANTED LIST
local function OnSelect(self)
	UIDropDownMenu_SetSelectedID(delenemy, self:GetID())
	ddelenemy = self:GetText()
	--print(self:GetText()) -- print numero
	--print(ddelenemy)
end

local function initialize(self, level)
local toSort = {}
for k in pairs(BangHateds) do toSort[#toSort + 1] = k end
table.sort(toSort)
--for i = 1, #toSort do print(toSort[i]) end

local info=UIDropDownMenu_CreateInfo()
    for k,v in pairs(toSort) do
		info=UIDropDownMenu_CreateInfo()
		info.text=v
		info.value=v
		info.func=OnSelect
		UIDropDownMenu_AddButton(info, level)
    end
end

local function Init(delenemy)
    UIDropDownMenu_Initialize(delenemy, initialize)
    UIDropDownMenu_SetWidth(delenemy, 120)
    UIDropDownMenu_SetButtonWidth(delenemy, 124)
    UIDropDownMenu_SetSelectedID(delenemy, 1)
	UIDropDownMenu_JustifyText(delenemy, "LEFT")
end

Gui.func3frame.del = CreateFrame("Button", "delenemy", Gui.func3frame, "UIPanelButtonTemplate")
Gui.func3frame.del:SetSize(50,22)
Gui.func3frame.del:SetPoint("CENTER", 70, -10)
Gui.func3frame.del:SetText("Del")
Gui.func3frame.del:SetScript("OnClick", function(self)
	BangHateds[ddelenemy] = nil;
	print("|cffFE2E2E- Deleted |r" ..ddelenemy.." |cffFE2E2Efrom wanted list.")
	Init(delenemy) -- hace reload al listado despues de borrar

end)
Init(delenemy) -- nombre frames

-- BRUTAL
--local toSort = {}
--for k in pairs(BangCharHateds) do toSort[#toSort + 1] = k end
--table.sort(toSort)
--for i = 1, #toSort do print(toSort[i]) end
--

-- SORT TABLE BY KILLS
function spairs(BangKills, order)
    local tkills = {}
    for k in pairs(BangKills) do tkills[#tkills + 1] = k end
    if order then
   -- if order then
        table.sort(tkills, function(a,b) return order(BangKills, a, b) end)
    else
        table.sort(tkills)
    end
    local i = 0
    return function()
        i = i + 1
Gui.func1frame.topkills2 = CreateFrame("MessageFrame", nil, Gui.func1frame)
Gui.func1frame.topkills2:SetSize(50,100)
Gui.func1frame.topkills2:SetPoint("TOP", -60, -40)
Gui.func1frame.topkills2:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Gui.func1frame.topkills2:SetFading(false)
Gui.func1frame.topkills2:SetSpacing(0)
Gui.func1frame.topkills2:SetJustifyH("CENTER")
Gui.func1frame.topkills2:AddMessage("BANGS", 1, .8, 0, 1)
        if tkills[1] then
			Gui.func1frame.topkills2:AddMessage(BangKills[tkills[1]], 0, .8, 0, 1)
		else
			Gui.func1frame.topkills2:AddMessage("0", 0, .8, 0, 1)
        end
        if tkills[2] then
			Gui.func1frame.topkills2:AddMessage(BangKills[tkills[2]], 0, .8, 0, 1)
		else
			Gui.func1frame.topkills2:AddMessage("0", 0, .8, 0, 1)
        end
        if tkills[3] then
			Gui.func1frame.topkills2:AddMessage(BangKills[tkills[3]], 0, .8, 0, 1)
		else
			Gui.func1frame.topkills2:AddMessage("0", 0, .8, 0, 1)
        end
		if tkills[4] then
			Gui.func1frame.topkills2:AddMessage(BangKills[tkills[4]], 0, .8, 0, 1)
		else
			Gui.func1frame.topkills2:AddMessage("0", 0, .8, 0, 1)
        end
		if tkills[5] then
			Gui.func1frame.topkills2:AddMessage(BangKills[tkills[5]], 0, .8, 0, 1)
		else
			Gui.func1frame.topkills2:AddMessage("0", 0, .8, 0, 1)
        end
Gui.func1frame.topkills3 = CreateFrame("MessageFrame", nil, Gui.func1frame)
Gui.func1frame.topkills3:SetSize(250,100)
Gui.func1frame.topkills3:SetPoint("TOP", 165, -40)
Gui.func1frame.topkills3:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Gui.func1frame.topkills3:SetFading(false)
Gui.func1frame.topkills3:SetSpacing(0)
Gui.func1frame.topkills3:SetJustifyH("LEFT")
--
Gui.func1frame.topkills3:AddMessage("NAME", 1, .8, 0, 1)
        if tkills[1] then
			Gui.func1frame.topkills3:AddMessage(tkills[1], 1, 1, 1, 1)
		else
			Gui.func1frame.topkills3:AddMessage("0", 1, 1, .1, 1)
        end
        if tkills[2] then
			Gui.func1frame.topkills3:AddMessage(tkills[2], .9, .9, .9, 1)
		else
			Gui.func1frame.topkills3:AddMessage("0", 9, .9, .9, 1)
        end
        if tkills[3] then
			Gui.func1frame.topkills3:AddMessage(tkills[3], .7, .7, .7, 1)
		else
			Gui.func1frame.topkills3:AddMessage("0", 7, .7, .7, 1)
        end
		if tkills[4] then
			Gui.func1frame.topkills3:AddMessage(tkills[4], .6, .6, .6, 1)
		else
			Gui.func1frame.topkills3:AddMessage("0", .6, .6, .6, 1)
        end
		if tkills[5] then
			Gui.func1frame.topkills3:AddMessage(tkills[5], .5, .5, .5, 1)
		else
			Gui.func1frame.topkills3:AddMessage("0", .5, .5, .5, 1)
        end
Gui.func1frame.topkills4 = CreateFrame("MessageFrame", nil, Gui.func1frame)
Gui.func1frame.topkills4:SetSize(50,100)
Gui.func1frame.topkills4:SetPoint("TOP", 0, -40)
Gui.func1frame.topkills4:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Gui.func1frame.topkills4:SetFading(false)
Gui.func1frame.topkills4:SetSpacing(0)
Gui.func1frame.topkills4:SetJustifyH("CENTER")
Gui.func1frame.topkills4:AddMessage("DEATHS", 1, .8, 0, 1)
        if BangDeaths[tkills[1]] then
			Gui.func1frame.topkills4:AddMessage(BangDeaths[tkills[1]], .8, 0, 0, 1)
		else
			Gui.func1frame.topkills4:AddMessage("0", .8, 0, 0, 1)
        end
        if BangDeaths[tkills[2]] then
		Gui.func1frame.topkills4:AddMessage(BangDeaths[tkills[2]], .8, 0, 0, 1)
		else
			Gui.func1frame.topkills4:AddMessage("0", .8, 0, 0, 1)
        end
        if BangDeaths[tkills[3]] then
		Gui.func1frame.topkills4:AddMessage(BangDeaths[tkills[3]], .8, 0, 0, 1)
		else
			Gui.func1frame.topkills4:AddMessage("0", .8, 0, 0, 1)
        end
        if BangDeaths[tkills[4]] then
		Gui.func1frame.topkills4:AddMessage(BangDeaths[tkills[4]], .8, 0, 0, 1)
		else
			Gui.func1frame.topkills4:AddMessage("0", .8, 0, 0, 1)
        end
        if BangDeaths[tkills[5]] then
		Gui.func1frame.topkills4:AddMessage(BangDeaths[tkills[5]], .8, .0, .0, 1)
		else
			Gui.func1frame.topkills4:AddMessage("0", .8, 0, 0, 1)
        end
	end
end

for k,v in spairs(BangKills, function(BangKills,a,b) return BangKills[b] < BangKills[a] end) do end -- prints tabla tops

Gui.func1frame.topkills1 = CreateFrame("MessageFrame", nil, Gui.func1frame)
Gui.func1frame.topkills1:SetSize(50,100)
Gui.func1frame.topkills1:SetPoint("TOP", -110, -40)
Gui.func1frame.topkills1:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Gui.func1frame.topkills1:SetFading(false)
Gui.func1frame.topkills1:SetSpacing(0)
Gui.func1frame.topkills1:SetJustifyH("CENTER")
Gui.func1frame.topkills1:AddMessage("TOP ", 1, .8, 0, 1)
Gui.func1frame.topkills1:AddMessage("#1", 1, .7, .05, 1)
Gui.func1frame.topkills1:AddMessage("#2", .8, .8, .8, 1)
Gui.func1frame.topkills1:AddMessage("#3", .6, .35, 0, 1)
Gui.func1frame.topkills1:AddMessage("#4", .6, .6, .6, 1)
Gui.func1frame.topkills1:AddMessage("#5", .5, .5, .5, 1)
--
--WANTED TOP LIST
-- 
Gui.func1frame.htopkills1 = CreateFrame("MessageFrame", nil, Gui.func1frame)
Gui.func1frame.htopkills1:SetSize(50,100)
Gui.func1frame.htopkills1:SetPoint("TOP", -110, 40)
Gui.func1frame.htopkills1:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Gui.func1frame.htopkills1:SetFading(false)
Gui.func1frame.htopkills1:SetSpacing(0)
Gui.func1frame.htopkills1:SetJustifyH("CENTER")
Gui.func1frame.htopkills1:AddMessage("TOP ", 1, .8, 0, 1)
Gui.func1frame.htopkills1:AddMessage("#1", 1, .7, .05, 1)
Gui.func1frame.htopkills1:AddMessage("#2", .65, .65, .65, 1)
Gui.func1frame.htopkills1:AddMessage("#3", .6, .35, 0, 1)
--
Gui.func1frame.htopkills2 = CreateFrame("MessageFrame", nil, Gui.func1frame)
Gui.func1frame.htopkills2:SetSize(50,100)
Gui.func1frame.htopkills2:SetPoint("TOP", -60, 40)
Gui.func1frame.htopkills2:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Gui.func1frame.htopkills2:SetFading(false)
Gui.func1frame.htopkills2:SetSpacing(0)
Gui.func1frame.htopkills2:SetJustifyH("CENTER")
Gui.func1frame.htopkills2:AddMessage("BANGS", 1, .8, 0, 1)
Gui.func1frame.htopkills2:AddMessage("0", 0, .8, 0, 1)
Gui.func1frame.htopkills2:AddMessage("0", 0, .8, 0, 1)
Gui.func1frame.htopkills2:AddMessage("0", 0, .8, 0, 1)
--
Gui.func1frame.htopkills3 = CreateFrame("MessageFrame", nil, Gui.func1frame)
Gui.func1frame.htopkills3:SetSize(50,100)
Gui.func1frame.htopkills3:SetPoint("TOP", 0, 40)
Gui.func1frame.htopkills3:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Gui.func1frame.htopkills3:SetFading(false)
Gui.func1frame.htopkills3:SetSpacing(0)
Gui.func1frame.htopkills3:SetJustifyH("CENTER")
Gui.func1frame.htopkills3:AddMessage("DEATHS", 1, .8, 0, 1)
Gui.func1frame.htopkills3:AddMessage("0", .8, 0, 0, 1)
Gui.func1frame.htopkills3:AddMessage("0", .8, 0, 0, 1)
Gui.func1frame.htopkills3:AddMessage("0", .8, 0, 0, 1)
--
Gui.func1frame.htopkills4 = CreateFrame("MessageFrame", nil, Gui.func1frame)
Gui.func1frame.htopkills4:SetSize(250,100)
Gui.func1frame.htopkills4:SetPoint("TOP", 165, 40)
Gui.func1frame.htopkills4:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Gui.func1frame.htopkills4:SetFading(false)
Gui.func1frame.htopkills4:SetSpacing(0)
Gui.func1frame.htopkills4:SetJustifyH("LEFT")
Gui.func1frame.htopkills4:AddMessage("WANTED NAME", 1, .8, 0, 1)
Gui.func1frame.htopkills4:AddMessage("doesn't work yet", 1, 1, 1, 1)
Gui.func1frame.htopkills4:AddMessage("be", .9, .9, .9, 1)
Gui.func1frame.htopkills4:AddMessage("patient, ty", .7, .7, .7, 1)

--END

--print(v, k)
	--end
--	table.sort(toSort)
--	for i = 1, #toSort do
		--print(toSort[i])
-- END


end
BangDB:SetScript("OnEvent", eventHandler);
--


