-- Copyright 2011 Xavier Ferrair aka Mortimer @ Outland [H] (deadlygm@gmail.com)
-- no code in this file may be used in other works without expressed permission

local HKSreporter = CreateFrame("Frame")

	HKSreporter:RegisterEvent("CHAT_MSG_OFFICER")
	HKSreporter:RegisterEvent("CHAT_MSG_PARTY_LEADER")
	HKSreporter:RegisterEvent("CHAT_MSG_RAID_LEADER")
	HKSreporter:SetScript("OnEvent", function(self, event, msg)
	inInstance, instanceType = IsInInstance()
	
			if event == "CHAT_MSG_OFFICER" and msg == "!hks" then
				local hk, honorKills;
					honorKills, honorPoints = GetPVPSessionStats("player");
					hk, highestRank = GetPVPLifetimeStats("player");
				SendChatMessage("* "..honorKills.." hkills of "..hk.."", "OFFICER", NIL);
			end

			-- Party leader only can type !hks
			if event == "CHAT_MSG_PARTY_LEADER" and msg == "!hks" and not UnitInRaid("player") and (instanceType == "none") then
				local hk, honorKills;
					honorKills, honorPoints = GetPVPSessionStats("player");
					hk, highestRank = GetPVPLifetimeStats("player");
				SendChatMessage("* "..honorKills.." hkills of "..hk.."", "PARTY", NIL);
			end
			-- Raid leader only can type !hks and ignore party if exists raid
			if event == "CHAT_MSG_RAID_LEADER" and msg == "!hks" and UnitInRaid("player") and (instanceType == "none") then
				local hk, honorKills;
					honorKills, honorPoints = GetPVPSessionStats("player");
					hk, highestRank = GetPVPLifetimeStats("player");
				SendChatMessage("* "..honorKills.." hkills of "..hk.."", "RAID", NIL);
			end
end)