-- Copyright 2011 Xavier Ferrair aka Mortimer @ Outland [H] (deadlygm@gmail.com)
-- no code in this file may be used in other works without expressed permission

--local hk, honorKills, rating, ratingg, ratinggg
local BB_Name = GetAddOnMetadata("Bang_Bang", "Name");
local BB_Version = tonumber(GetAddOnMetadata("Bang_Bang", "Version"));

local this = CreateFrame("Frame")
this:RegisterEvent("PLAYER_LOGIN")
this:RegisterEvent("ADDON_LOADED");
this:RegisterEvent("PLAYER_ENTERING_WORLD");
this:SetScript("OnEvent", function(self, event, ...)
    if event == "ADDON_LOADED" and ... == "Bang_Bang" then
	--        if not BangHateds then BangHateds = {} end
        if not BangCharDB then BangCharDB = {} end
			if BangCharDB.MinimapPos == nil then
			BangCharDB = { MinimapPos = 45 }
			else
				BANG_MinimapButton_Reposition()
				self:UnregisterEvent("ADDON_LOADED");
			end
	end
	
	if (event == "PLAYER_ENTERING_WORLD") then
		if not IsAddOnLoaded("Blizzard_PVPUI") then
			LoadAddOn("Blizzard_PVPUI")
		end
		DEFAULT_CHAT_FRAME:AddMessage("|cffFFD800Bang! Bang! |cff2EFE2E"..BB_Version.." |rloaded.");
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
    end
	
	
end)

SLASH_BB1 = "/bb";
local function BBCmdLine()
	GetOnClick()
end
SlashCmdList["BB"] = BBCmdLine;

function BANG_MinimapButton_Reposition()
	BANG_MinimapButton:SetPoint("TOPLEFT","Minimap","TOPLEFT",52-(80*cos(BangCharDB.MinimapPos)),(80*sin(BangCharDB.MinimapPos))-52)
	BANG_MinimapButton:RegisterForClicks("AnyUp");-- esto hace que detecte los botones del mouse
	BANG_MinimapButton:SetScript("OnClick", function(self, button)
		if button == "LeftButton" then GetOnClick() end
		if button == "RightButton" then GetOnRClick() end
	end)

	hooksecurefunc("ToggleGameMenu", function() Gui:Hide() end)
	BANG_MinimapButton:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	BANG_MinimapButton:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
			honorKills, honorPoints = GetPVPSessionStats("player")
			hk, highestRank = GetPVPLifetimeStats("player")
			rating = GetPersonalRatedInfo(1) --2v2
			ratingg = GetPersonalRatedInfo(2) --3v3
			ratinggg = GetPersonalRatedInfo(4) --10v10
	GameTooltip:AddLine("|cffFFD800Bang! Bang! "..BB_Version, 1, 0.82, 0, 1) -- |cff2EFE2E verde / rojo |cffFE2E2E
	GameTooltip:AddLine("Release version", 0, 0.82, 0, 1)
	GameTooltip:AddLine("|cffFE2E2EHks: |cffDDDDDD"..honorKills.." |cff777777"..hk, 0, 0.82, 0, 1)
	GameTooltip:AddLine("|cffdf74012v2:|cffDDDDDD "..rating.." |cffdf74013v3:|cffDDDDDD "..ratingg.." |cffdf740110v10:|cffDDDDDD "..ratinggg, 0, 0.82, 0, 1)
	GameTooltip:Show()
	end)
end

--local realmName = GetRealmName(); DEFAULT_CHAT_FRAME:AddMessage("You are currently on realm: " .. realmName)

-- Only while the button is dragged this is called every frame
function BANG_MinimapButton_DraggingFrame_OnUpdate()

	local xpos,ypos = GetCursorPosition()
	local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom()

	xpos = xmin-xpos/UIParent:GetScale()+70 -- get coordinates as differences from the center of the minimap
	ypos = ypos/UIParent:GetScale()-ymin-70

	BangCharDB.MinimapPos = math.deg(math.atan2(ypos,xpos)) -- save the degrees we are relative to the minimap center
	BANG_MinimapButton_Reposition() -- move the button
end

function GetOnClick()
	Gui:Show() -- Mostrando interfaz
	Gui.func1frame:Show()
	Gui.func2frame:Hide()
	Gui.func3frame:Hide()
	Gui.func4frame:Hide()
end

function GetOnRClick()
	local url = "2v2: "..rating.." - 3v3: "..ratingg.." - 10v10: "..ratinggg
	if url then
		local edit_box = ChatEdit_ChooseBoxForSend()
		ChatEdit_ActivateChat(edit_box)
		if url then
			edit_box:Insert("");
			edit_box:Insert(url);
			edit_box:HighlightText();
		end
	end
end


function gggGetOnRClick()
local hk, honorKills;
	honorKills, honorPoints = GetPVPSessionStats("player");
	hk, highestRank = GetPVPLifetimeStats("player");
--	DEFAULT_CHAT_FRAME:AddMessage("|cffFE2E2ECurrent honorable kills:|r "..honorKills.." |cffFE2E2Eof |r"..hk.."");
end