-- Copyright 2011 Xavier Ferrair aka Mortimer @ Outland [H] (deadlygm@gmail.com)
-- no code in this file may be used in other works without expressed permission

local f = CreateFrame("Frame")
f:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

trinket = CreateFrame("MessageFrame", nil, UIParent)
trinket:SetSize(100,30)
trinket:SetPoint("CENTER", 0, 205)
trinket:SetFont("Fonts\\FRIZQT__.ttf", 15, "THINOUTLINE")
trinket:SetFading(true)
trinket:SetTimeVisible(1)
trinket.a = CreateFrame("MessageFrame", nil, trinket)
trinket.a:SetSize(400,30)
trinket.a:SetPoint("CENTER", 0, -30)
trinket.a:SetFont("Fonts\\FRIZQT__.ttf", 30, "THINOUTLINE")
trinket.a:SetFading(true)
trinket.a:SetTimeVisible(1)
function BangTrinketAlert(ltext,bigText)
	if trinket:IsVisible() or streaks:IsVisible() then 
		trinket:Hide(); trinket.a:Hide(); streaks:Hide(); streaks.a:Hide();
		trinket:Show(); trinket.a:Show(); streaks:Show(); streaks.a:Show();
	end
trinket:AddMessage(ltext, 1, 1, 1, 1)
trinket.a:AddMessage(bigText, 0, 1, 0, 1)
end
--BangTrinketAlert("- trinket -","MEDALLION USED!");

f:SetScript("OnEvent", function(self, event, ...)

local timeStamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, prefixParam1, prefixParam2, dummyparam, suffixParam1, suffixParam2, school, resisted, blocked, absorbed, critical = ...	
local playerName = UnitName("player");
local tarName = UnitName("target");

	if (event == "SPELL_AURA_APPLIED") and prefixParam1 == 54861 and sourceName == playerName then
		SendChatMessage("shit's on fire yo", "YELL");
	end
	if (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH") and prefixParam1 == 6770 and destName == playerName then
		SendChatMessage("Sapped","SAY");
	end
	
	-- 195756 195901
	-- gladiator's medallion 208683
	-- adaptation 214027
	-- PvP Trinket 42292 100 lvl
	--	[195710] = 180, -- Honorable Medallion
	--	[208683] = 120, -- Gladiator's Medallion
	--	[195901] = 60, -- Adapted Debuff
	--	[59752] = 1,	-- Every Man for Himself
	--	[7744] = 1,		-- Will of the Forsaken
	--	[20594] = 1,	-- Stoneform

	if BangCharDB.Chk6 == true then
		if (event == "SPELL_CAST_SUCCESS") and prefixParam1 == 195710 and sourceGUID == UnitGUID("target") and bit.band(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then
			RaidNotice_AddMessage(RaidBossEmoteFrame, "\124cFF00FF00\*** Honorable Medallion ***", ChatTypeInfo["RAID_BOSS_EMOTE"])
			BangTrinketAlert("- trinket -","HONORABLE MEDALLION");
			PlaySoundFile("Sound\\Interface\\Alarmclockwarning3.ogg", "Master");
			print("|cff2EFE2E"..tarName.." Honorable Medallion used!");
		end
		if (event == "SPELL_CAST_SUCCESS") and prefixParam1 == 208683 and sourceGUID == UnitGUID("target") and bit.band(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then
			BangTrinketAlert("- trinket -","GLADIATOR'S MEDALLION");
			PlaySoundFile("Sound\\Interface\\Alarmclockwarning3.ogg", "Master");
			print("|cff2EFE2E"..tarName.." Gladiator's Medallion used!");
		end
		if (event == "SPELL_CAST_SUCCESS") and prefixParam1 == 195901 and sourceGUID == UnitGUID("target") and bit.band(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then
			BangTrinketAlert("- trinket -","ADAPTATION");
			PlaySoundFile("Sound\\Interface\\Alarmclockwarning3.ogg", "Master");
			print("|cff2EFE2E"..tarName.." Adaptation used!");
		end
		if (event == "SPELL_CAST_SUCCESS") and prefixParam1 == 59752 and sourceGUID == UnitGUID("target") and bit.band(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then
			BangTrinketAlert("- racial -","EVERY MAN FOR HIMSELF");
			PlaySoundFile("Sound\\Interface\\Alarmclockwarning3.ogg", "Master");
			print("|cff2EFE2E"..tarName.." Every Man for Himself racial used!");
		end
		if (event == "SPELL_CAST_SUCCESS") and prefixParam1 == 195710 and sourceGUID == UnitGUID("target") and bit.band(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then
			BangTrinketAlert("- racial -","WILL OF THE FORSAKEN");
			PlaySoundFile("Sound\\Interface\\Alarmclockwarning3.ogg", "Master");
			print("|cff2EFE2E"..tarName.." Will of the Forsaken racial used!");
		end
		if (event == "SPELL_CAST_SUCCESS") and prefixParam1 == 20594 and sourceGUID == UnitGUID("target") and bit.band(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then
			BangTrinketAlert("- racial -","STONEFORM");
			PlaySoundFile("Sound\\Interface\\Alarmclockwarning3.ogg", "Master");
			print("|cff2EFE2E"..tarName.." Stoneform racial racial used!");
		end
	end
end)